using Back.Common;
using Back.Services;
using FluentValidation;
using Shared.DTOs;

namespace Back.Validations
{
    // companyid invoiceid model
    public class AUInvoicePayValidation : AbstractValidator<Tuple<int, int, InvoicePaymentDTO, eActionValidation>>
    {
        public AUInvoicePayValidation(servInvoice servInvoice, servTaxPayer servTaxPayer, servInvoicePayment servInvoicepay)
        {
            When(m => m.Item4 == eActionValidation.update, () =>
            {
                RuleFor(r => r)
              .Custom((model, context) =>
              {
                  if (!model.Item3.ID.HasValue)
                      context.AddFailure("شناسه در حالت ویرایش نمی تواند خالی باشد");
                  if (!servInvoicepay.Exist(model.Item1, model.Item2, model.Item3.ID.Value).Result)
                      context.AddFailure("شناسه یافت نشد");

              });

            });

            RuleFor(r => r)
            .Custom((model, context) =>
            {
                if (model.Item2 != null && model.Item2 > 0)
                {
                    var invoice = servInvoice.GetInvoiceByInvoiceID(model.Item1, model.Item2).Result;
                    if (invoice == null)
                        context.AddFailure("صورتحساب یافت نشد");


                    else
                    {
                        if (model.Item4 == eActionValidation.update || model.Item4 == eActionValidation.add)
                        {
                            if (model.Item3.pv <= 0)
                            {
                                context.AddFailure("مبلغ پرداختی باید بیشتر از صفر باشد.");
                            }

                            var totalpay = invoice.payments.Sum(s => s.pv).GetValueOrDefault() + model.Item3.pv;
                            if (totalpay > invoice.tbill) context.AddFailure("مجموع مبلغ پرداختی نمی تواند از مجموع صورتحساب بیشتر باشد.");
                            else
                            {
                                if (model.Item3.pmt.HasValue && model.Item3.pmt.Value > 0 && model.Item3.pmt.Value < 9)
                                {
                                    if (string.IsNullOrEmpty(model.Item3.PaymentDateTime))
                                    {
                                        context.AddFailure("تاریخ نمیتواند خالی باشد");
                                    }
                                    else
                                    {
                                        var today = Convert.ToInt32(DateTime.Now.ConvertMiladiToShamsi());
                                        string paydate = model.Item3.PaymentDateTime.Replace("/", "");

                                        if (paydate.Length == 8 && int.TryParse(paydate, out int _paydate))
                                        {
                                            if (today >= _paydate)
                                            {
                                                if (Convert.ToInt32(invoice.InvoiceDate) > _paydate)
                                                {
                                                    context.AddFailure("تاریخ پرداخت نمیتواند از تاریخ صورتحساب عقبتر باشد");
                                                }
                                            }
                                            else
                                            {
                                                context.AddFailure("تاریخ پرداخت نمی تواند از امروز جلوتر باشد");
                                            }


                                        }
                                        else context.AddFailure("تاریخ صحیح نمی باشد");
                                    }

                                }
                                else context.AddFailure("روش پرداخت مشخص نشده");
                            }


                        }

                        if (servTaxPayer.ExistSuccessfulorSendorpendingInvoice(invoice).Result)
                            context.AddFailure("این صورتحساب به سازمان ارسال شده" + '\n' +
                       "برای تغییر ،صورتحساب را ابطال/اصلاح یا برگشت بزنید");
                        else if ((model.Item4 == eActionValidation.add || model.Item4 == eActionValidation.delete)
                    && invoice.invoiceType == InvoiceType.BackFrmSale)
                            context.AddFailure("پرداخت های صورتحساب در وضعیت برگشت از فروش نمی تواند اضافه یا کم شود");
                        else if (invoice.invoiceType != InvoiceType.Bidding
                        && invoice.invoiceType != InvoiceType.Sale && invoice.invoiceType != InvoiceType.Repair)
                        {
                            context.AddFailure($"صورتحساب در حالت {invoice.invoiceType.GetEnumDisplayName()} نمی تواند ویرایش شود" + '\n' +
                                $"فقط در حالت پیش نویس ، فاکتور و اصلاح (که به سازمان ارسال نشده باشد) میتوان سند را ویرایش کرد");
                        }
                    }
                }

                else context.AddFailure("صورتحساب صحیح نمی باشد");

            });

        }
    }
}
